int windowSize = 480;
int center = windowSize/2;
int circleRadius = 7;
int textX = windowSize-180;
int textY = windowSize-15;
int nrNodes = 700;

//general phyllotree variables
float c = 7.0;
float phyl_angle = 137.5;
float nodesStep = (float)nrNodes / (float) windowSize;

boolean animation = false;

PImage bg;

//for the automated increase
float stepSize = 0.1;

//for the increase by mouse movement
float angleStep = 180.0 / (float) windowSize;


void setup() 
{ 
  bg = loadImage("sonnenblume.jpg");
  size(windowSize, windowSize);    
  color filling = color(20, 70, 162);  //blue
  color drawing = color(198, 193, 107); //dark yellow
  fill(filling);     
  stroke(drawing);
  PFont fontA = loadFont("CourierNew36.vlw"); 
  textFont(fontA, 12); 
  framerate(10);
  smooth(); 
} 

void keyPressed(){
  
  if(key == CODED) { 
    if (keyCode == LEFT)  phyl_angle -= angleStep;   
    else if(keyCode == RIGHT)  phyl_angle += angleStep;
    else if(keyCode == UP) nrNodes += nodesStep;
    else if(keyCode == DOWN) nrNodes -= nodesStep;
  }
  
  else if(key ==' '){
      animation = !animation;
      if(animation) loop();
      else noLoop();
  }
  else if(key == 'c'){
   c += 0.1; 
  }
  else if(key == 'x'){
    c -= 0.1;
    }
  redraw();
}

void mouseMoved(){
  nrNodes = (int) (mouseY * nodesStep);
  
  if(!animation) {
    phyl_angle = angleStep * (float) mouseX;
    redraw();
    }
}
  
void draw() 
{ 
  
  background(bg);   // Set the background to black 

  if(animation) phyl_angle += stepSize;
  
  text("angular constant: " + phyl_angle , textX, textY);
      
  for(int n = 0; n < nrNodes; n++){
  
      float radius = c * sqrt(n);
      float angleInDegrees  = n * phyl_angle;
      float angle = radians(angleInDegrees);
      
      float x = radius * cos(angle) + center;
      float y = radius * sin(angle) + center;
      
      ellipse(x, y, circleRadius, circleRadius); 
  }
} 
